<?php
/*******************************************************************************

    Author ......... Thomas Urban
    Contact ........ nmid@urban-software.de
    Home Site ...... http://www.urban-software.de
    Program ........ nmidWeb2 Addon for Cacti 
    Version ........ 0.2
    Purpose ........ Displaying the Graphs within a portlet to be moved around
*******************************************************************************/

function plugin_init_nmidWeb2() {
	global $plugin_hooks;
	$plugin_hooks['page_head']['nmidWeb2'] = 'nmidWeb2_page_head';
}

function plugin_nmidWeb2_install () {
	api_plugin_register_hook('nmidWeb2', 'page_head', 'nmidWeb2_page_head', 'setup.php');
	nmidWeb2_setup_table_new ();
}

function plugin_nmidWeb2_uninstall () {
	// Do any extra Uninstall stuff here
}

function plugin_nmidWeb2_check_config () {
	// Here we will check to ensure everything is configured
	nmidWeb2_check_upgrade();

	return true;
}

function nmidWeb2_page_head() {
	global $config;
	
	if ( isset($_GET['tree_id']) ) {
		if (!isset($_REQUEST["tree_id"])) { $_REQUEST["tree_id"] = "-1"; }
		if (!isset($_REQUEST["leaf_id"])) { $_REQUEST["leaf_id"] = "-1"; }
		if (!isset($_REQUEST["user_id"])) { $_REQUEST["user_id"] = "-1"; }
		if (!isset($_REQUEST["page"])) { $_REQUEST["page"] = "1"; }   //  page
		if (!isset($_REQUEST["graphs"])) { $_REQUEST["graphs"] = $_SESSION["sess_graph_view_graphs"]; }   // ipp
//		if (!isset($_REQUEST["thumbnails"])) { $_REQUEST["thumbnails"] = "0"; } // thumbnails
	?>
	<link type="text/css" href="<?php echo $config['url_path']; ?>plugins/nmidWeb2/css/redmond/jquery-ui-1.7.2.custom.css" rel="stylesheet" />
	<script type="text/javascript" src="<?php echo $config['url_path']; ?>plugins/nmidWeb2/js/jquery-1.3.2.min.js"></script>
	<script type="text/javascript" src="<?php echo $config['url_path']; ?>plugins/nmidWeb2/js/jquery-ui-1.7.2.custom.min.js"></script>
	<style type="text/css">
	.column { width: 100%; float: left; padding-bottom: 100px; }
	.portlet { margin: 0 1em 1em 0; }
	.portlet-header { margin: 0.3em; padding-bottom: 4px; padding-left: 0.2em; }
	.portlet-header .ui-icon { float: right; }
	.portlet-content { padding: 0.4em; }
	.ui-sortable-placeholder { border: 1px dotted black; visibility: visible !important; height: 50px !important; }
	.ui-sortable-placeholder * { visibility: hidden; }
	</style>
	<script type="text/javascript">
	///////////////////////////////////////////////////////////////// 
	/////  Set cookie for sidebar portlets  ////////////////////// 
	///////////////////////////////////////////////////////////////// 

	// set the list selector 
	var setSelector = "#wideSidebar"; 

	//////////////////////////////////////////////////////////////// 

	// function that restores the list order from a cookie 
	function restoreOrder() { 

	        var list = $(setSelector); 
        	if (list == null) return 

        	// make array from saved order 
	        var ArrayString = <?php
				$sortOrder = db_fetch_cell("
					SELECT sortorder
					FROM
						plugin_nmidWeb2_sort_order
					WHERE
						userid='".$_SESSION["sess_user_id"]."'
					AND
						treeId='".$_REQUEST['tree_id']."'
					AND
						leafId='".$_REQUEST['leaf_id']."'
					AND
						page='".$_REQUEST['page']."'
					AND
						ipp='".$_REQUEST['graphs']."'
					AND
						tn='".$_REQUEST['thumbnails']."'
						");
				echo "\"$sortOrder\";";
			?>

		var IDs  = ArrayString.split(",");

	        // fetch current order 
        	var items = list.sortable("toArray"); 
	        // make array from current order 
        	var rebuild = new Array(); 
	        for ( var v=0, len=items.length; v<len; v++ ){ 
        	        rebuild[items[v]] = items[v]; 
	        } 


        	for (var i = 0, n = IDs.length; i < n; i++) { 


                	// item id from saved order 
	                var itemID = IDs[i]; 


        	        if (itemID in rebuild) { 


                	        // select item id from current order 
                        	var item = rebuild[itemID]; 


	                        // select the item according to current order 
        	                var child = $("div.ui-sortable").children("#" + item); 


                	        // select the item according to the saved order 
                        	var savedOrd = $("div.ui-sortable").children("#" + itemID); 


	                        // remove all the items 
        	                child.remove(); 


                	        // add the items in turn according to saved order we need to filter here since the "ui-sortable" 
                        	// class is applied to all ul elements and we only want the very first! 
	                        $("div.ui-sortable").filter(":first").append(savedOrd); 
                	} 
        	} 
	} 


	// code executed when the document loads 
	$(function () { 
                $(setSelector).sortable({ 
					stop: function(i) {
						$.ajax({
							type: "GET",
							url: "<?php echo $config['url_path'];?>plugins/nmidWeb2/updatedb_nmidWeb2.php?user_id=<?php echo $_SESSION["sess_user_id"];?>&ipp=<?php echo $_REQUEST['graphs']?>&page=<?php echo $_REQUEST['page']?>&tn=<?php echo $_REQUEST['thumbnails']?>&tree_id=<?php echo $_REQUEST['tree_id']?>&leaf_id=<?php echo $_REQUEST['leaf_id']?>",
							data: $(setSelector).sortable("serialize")
						});
					}
                });
                restoreOrder();
				$(setSelector).sortable( "refresh" );
                // here, we reload the saved order       

                $(".portlet").addClass("ui-widget ui-widget-content ui-helper-clearfix ui-corner-all")
				.find(".portlet-header") 
                                .addClass("ui-widget-header ui-corner-all") 
                                .prepend('<span class="ui-icon ui-icon-minusthick"></span>') 
                                .end() 
                        .find(".portlet-content"); 


                        $(".portlet-header .ui-icon").click(function() { 
			$(this).toggleClass("ui-icon-minusthick").toggleClass("ui-icon-plusthick");
                        $(this).parents(".portlet:first").find(".portlet-content").toggle(); 
                }); 

                $(".portlet-header .ui-icon").hover( 
                        function() {$(this).addClass("ui-icon-hover"); }, 
                        function() {$(this).removeClass('ui-icon-hover'); } 
                ); 
		$(setSelector).disableSelection();
	}); 
	</script>
	<?php
	}
	return;
}

function plugin_nmidWeb2_upgrade () {
	// Here we will upgrade to the newest version
	nmidWeb2_check_upgrade ();
	return false;
}

function plugin_nmidWeb2_version () {
	return nmidWeb2_version();
}

function nmidWeb2_check_upgrade () {
	// Let's only run this check if we are on a page that actually needs the data
	//$files = array('setup.php');
	//if (isset($_SERVER['PHP_SELF']) && !in_array(basename($_SERVER['PHP_SELF']), $files))
	//	return;
	//
	//$current = nmidWeb2_version ();
	//$current = $current['version'];
	//$old = read_config_option('plugin_nmidWeb2_version');
	//if ($current != $old)
	//	nmidWeb2_setup_table();
}

function nmidWeb2_check_dependencies() {
	global $plugins, $config;
	return true;
}


function nmidWeb2_setup_table_new () {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");

    // Create Report Schedule Table
	$data = array();
	$data['columns'][] = array('name' => 'id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
	$data['columns'][] = array('name' => 'userid', 'type' => 'text', 'NULL' => false, 'default' => '');
	$data['columns'][] = array('name' => 'treeId', 'type' => 'varchar(1024)', 'NULL' => false);
	$data['columns'][] = array('name' => 'leafId', 'type' => 'varchar(1024)', 'NULL' => false);
	$data['columns'][] = array('name' => 'page', 'type' => 'varchar(1024)', 'NULL' => false);
	$data['columns'][] = array('name' => 'ipp', 'type' => 'varchar(1024)', 'NULL' => false);
	$data['columns'][] = array('name' => 'tn', 'type' => 'varchar(10)', 'NULL' => false);
	$data['columns'][] = array('name' => 'sortorder', 'type' => 'text', 'NULL' => false);
	$data['primary'] = 'id';
	$data['type'] = 'MyISAM';
	$data['comment'] = 'nmidWeb2 Sort Order';
	api_plugin_db_table_create ('nmidCreatePDF', 'plugin_nmidWeb2_sort_order', $data);
	
}


function nmidWeb2_version () {
	return array( 'name' 	=> 'nmidWeb2',
			'version' 	=> '0.4',
			'longname'	=> 'NMID Web2 Plugin',
			'author'	=> 'Thomas Urban',
			'homepage'	=> 'http://blog.network-outsourcing.de',
			'email'	=> 'nmid@urban-software.de',
			'url'		=> 'http://urban-software.de/nmid/nmidWeb2/versions.php'
			);
}

function nmidWeb2_setup_table () {
}

?>

